%global commit bafe630508a1a85b649a7d0134bd8112afd0de84
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global alphatag .%{shortcommit}git
%global project tempest

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%{?dlrn: %global tarsources %{project}-%{upstream_version}}
%{!?dlrn: %global tarsources %{project}-%{commit}}

Name:           openstack-%{project}
Epoch:          1
Version:        13.0.0
Release:        14%{alphatag}%{?dist}
Summary:        OpenStack Integration Test Suite (Tempest)
License:        ASL 2.0
# FIXME move to Upstream tempest
Url:            https://github.com/redhat-openstack/tempest
Source0:        https://github.com/redhat-openstack/tempest/archive/%{commit}.tar.gz#/%{project}-%{commit}.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=bafe630508a1a85b649a7d0134bd8112afd0de84
#
Patch0001: 0001-Added-fix-for-KeyError-exception-with-volume-service.patch
Patch0002: 0002-Require-l3-ha-extension-for-test_centralized_router_.patch
Patch0003: 0003-Do-not-have-heat-to-connect-to-external-service.patch
Patch0004: 0004-Fix-race-in-test_networks.py-don-t-try-to-get-a-poss.patch
Patch0005: 0005-Delete-duplicated-dvr-tests.patch
Patch0006: 0006-Remove-unused-arguments-from-_error_checker.patch
Patch0007: 0007-Remove-unused-arguments-from-_error_checker-from-neg.patch
Patch0008: 0008-Added-missing-tempest-plugin-test-subpackages.patch
Patch0009: 0009-Install-a-package-only-if-available.patch
Patch0010: 0010-Enable-configuration-of-manila-service.patch
Patch0011: 0011-Remove-the-Stress-framework.patch
Patch0012: 0012-Move-plugin-client-registration-to-proxy.patch
Patch0013: 0013-Add-plugin-group-names-to-CONF.patch
Patch0014: 0014-Fix-invalid-values-when-setting-config-options-defau.patch
Patch0015: 0015-Add-ability-to-remove-any-option-from-tempest.conf.patch
Patch0016: 0016-waiters.py-raise-BackupException-defined-in-tempest-.patch
Patch0017: 0017-Fix-config_tempest-failing-due-to-v3.patch

BuildArch:      noarch

BuildRequires:  fdupes
BuildRequires:  git
BuildRequires:  python-d2to1
BuildRequires:  python-oslo-config
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python2-devel

Requires:       python-tempest = %{epoch}:%{version}-%{release}

Requires:       python
Requires:       python-anyjson
Requires:       python-boto
Requires:       python-iso8601
Requires:       python-junitxml
Requires:       python-keyring
Requires:       python-lxml
Requires:       python-nose
Requires:       python-testresources
Requires:       subunit-filters
Requires:       which

Obsoletes:      openstack-tempest-icehouse < 20150319
Obsoletes:      openstack-tempest-juno < 20150319
Obsoletes:      openstack-tempest-liberty
Obsoletes:      openstack-tempest-kilo

%description
This is a set of integration tests to be run against a live OpenStack cluster.
Tempest has batteries of tests for OpenStack API validation, Scenarios, and
other specific tests useful in validating an OpenStack deployment.

%package -n    python-tempest
Summary:       Tempest Python library

Requires:      python-cliff
Requires:      python-debtcollector
Requires:      python-fixtures
Requires:      python-jsonschema
Requires:      python-netaddr
Requires:      python-oslo-concurrency
Requires:      python-oslo-config
Requires:      python-oslo-log
Requires:      python-oslo-i18n
Requires:      python-oslo-serialization
Requires:      python-oslo-utils
Requires:      python-os-testr
Requires:      python-paramiko
Requires:      python-pbr
Requires:      python-prettytable
Requires:      python-six
Requires:      python-stevedore
Requires:      python-testrepository
Requires:      python-testscenarios
Requires:      python-testtools
Requires:      python-urllib3
Requires:      PyYAML

%description -n python-tempest
This is a set of integration tests to be run against a live OpenStack cluster.
Tempest has batteries of tests for OpenStack API validation, Scenarios, and
other specific tests useful in validating an OpenStack deployment.

This package contains the tempest python library.

%package -n     python-tempest-tests
Summary:        Python Tempest tests
Requires:       python-tempest = %{epoch}:%{version}-%{release}

BuildRequires:  python-coverage
BuildRequires:  python-mock
BuildRequires:  python-oslotest
BuildRequires:  python-subunit

Requires:       python-coverage
Requires:       python-mock
Requires:       python-oslotest
Requires:       python-subunit

%description -n python-tempest-tests
This is a set of integration tests to be run against a live OpenStack cluster.
Tempest has batteries of tests for OpenStack API validation, Scenarios, and
other specific tests useful in validating an OpenStack deployment.

This package contains tests for the tempest python library.

%if 0%{?repo_bootstrap} == 0
%package -n    %{name}-all
Summary:       All OpenStack Tempest Plugins

Requires:      %{name} = %{epoch}:%{version}-%{release}

Requires:       python-aodh-tests
Requires:       python-ceilometer-tests
Requires:       python-cinder-tests
Requires:       python-designate-tests-tempest
Requires:       python-glance-tests
Requires:       python-gnocchi-tests
Requires:       python-heat-tests
Requires:       python-horizon-tests-tempest
Requires:       python-ironic-tests
Requires:       python-keystone-tests
Requires:       python-mistral-tests
Requires:       python-neutron-tests
Requires:       python-neutron-fwaas-tests
Requires:       python-neutron-lbaas-tests
Requires:       python-neutron-vpnaas-tests
Requires:       python-nova-tests
Requires:       python-sahara-tests-tempest
Requires:       python-swift-tests
Requires:       python-zaqar-tests
Requires:       python-manila-tests

%description -n %{name}-all
This is a set of integration tests to be run against a live OpenStack cluster.
Tempest has batteries of tests for OpenStack API validation, Scenarios, and
other specific tests useful in validating an OpenStack deployment.

This package contains all the tempest plugins.
%endif

%prep
%autosetup -n %{tarsources} -S git
# have dependencies being handled by rpms, rather than requirement files
rm -rf {test-,}requirements.txt

# remove shebangs and fix permissions
RPMLINT_OFFENDERS="tempest/cmd/list_plugins.py \
tempest/cmd/cleanup.py \
tempest/cmd/cleanup_service.py \
tempest/cmd/verify_tempest_config.py \
tempest/cmd/account_generator.py \
tempest/lib/cmd/skip_tracker.py \
tempest/lib/cmd/check_uuid.py"
sed -i '1{/^#!/d}' $RPMLINT_OFFENDERS
chmod u=rw,go=r $RPMLINT_OFFENDERS

%build
%{__python2} setup.py build

%install
mkdir -p %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}
cp -pr . %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}
# Remove unnecessary files
rm -rf %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}/.git*
rm -rf %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}/build
rm -f  %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}/doc/source/_static/.keep
rm -f  %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}/.mailmap
rm -f  %{buildroot}%{_datarootdir}/%{name}-%{upstream_version}/.coveragerc

%{__python2} setup.py install --skip-build --root %{buildroot}

# Generate tempest config
mkdir -p %{buildroot}%{_sysconfdir}/%{project}/
oslo-config-generator --config-file tempest/cmd/config-generator.tempest.conf \
    --output-file %{buildroot}%{_sysconfdir}/%{project}/tempest.conf

mkdir -p %{buildroot}/etc/tempest
mv %{buildroot}/usr/etc/tempest/* %{buildroot}/etc/tempest

%files
%license LICENSE
%doc README.rst
%{_datarootdir}/%{name}-%{upstream_version}
%{_bindir}/tempest
%{_bindir}/check-uuid
%{_bindir}/skip-tracker
%{_bindir}/subunit-describe-calls
%{_bindir}/tempest-account-generator
%{_bindir}/verify-tempest-config
%{_sysconfdir}/%{project}/*sample
%{_sysconfdir}/%{project}/*yaml
%config(noreplace) %{_sysconfdir}/%{project}/*.conf

%files -n python-tempest
%license LICENSE
%{python2_sitelib}/%{project}
%{python2_sitelib}/%{project}*.egg-info
%exclude %{python2_sitelib}/tempest/tests

%files -n python-tempest-tests
%license LICENSE
%{python2_sitelib}/tempest/tests

%if 0%{?repo_bootstrap} == 0
%files -n %{name}-all
%license LICENSE
%endif

%changelog
* Wed Aug 09 2017 Jason Joyce <jjoyce@redhat.com> 1:13.0.0-14%{alphatag}
- Fix config_tempest failing due to v3 (rhbz#1460925)
- waiters.py: raise BackupException defined in tempest/lib (rhbz#1455928)

* Fri May 19 2017 Jason Joyce <jjoyce@redhat.com> 1:13.0.0-12%{alphatag}
- Add ability to remove any option from tempest.conf
- Fix invalid values when setting config options' default value
- Add plugin group names to CONF
- Move plugin client registration to proxy
- Remove unused arguments from _error_checker() from negative_rest_client
- Fix race in test_networks.py: don't try to get a possibly-deleted network
- Require l3-ha extension for test_centralized_router_update_to_dvr

* Tue Mar 14 2017 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-11%{alphatag}
- Remove the Stress framework (rhbz#1423382)

* Mon Feb 13 2017 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-10%{alphatag}
- rhbz#1421822
- Enable configuration of manila service
- Install a package only if available
- Added missing tempest plugin test-subpackages

* Thu Jan 12 2017 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-9%{alphatag}
- Install a package only if available
- Added missing tempest plugin test-subpackages

* Fri Dec 02 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-8
- add Requires python-manila-tests (rhbz#1400709)

* Mon Nov 28 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-7%{alphatag}
- Remove unused arguments from _error_checker() from negative_rest_client
- Remove unused arguments from _error_checker()

* Fri Nov 18 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-6%{alphatag}
- Delete duplicated dvr tests (rhbz#1394744)

* Thu Nov 17 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-5%{alphatag}
- Fix race in test_networks.py: don't try to get a possibly-deleted network

* Tue Nov 08 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-4%{alphatag}
- Do not have heat to connect to external service
- Require l3-ha extension for test_centralized_router_update_to_dvr

* Mon Nov 07 2016 Jon Schlueter <jschluet@redhat.com> 1:13.0.0-3%{alphatag}
- Added fix for KeyError exception with volume service.

* Wed Oct 19 2016 Alfredo Moralejo <amoralej@redhat.com> 1:13.0.0-2.bafe630git
- Update to post 13.0.0  (bafe630508a1a85b649a7d0134bd8112afd0de84)

* Tue Oct 11 2016 Chandan Kumar <chkumar AT redhat.com> 1:13.0.0-1.0363596git
- Update to 13.0.0

* Fri Sep 23 2016 Alan Pevec <apevec AT redhat.com> 1:12.2.0-2.0f8baaegit
- Update to 12.2.0 redhat-openstack/tempest snapshot 0f8baae
